//---------------------------------------------------------------------------
// Organization:    Graphical Communication, IFP, DTU
// Context:         Exercises, 67277, Computer Graphics
//
// Created/revised: July 1998
// File:            vector.cc
// Purpose:
//
//
//---------------------------------------------------------------------------


#include <iostream.h>
#include <math.h>
#include "default.h"
#include "vector.h"


//---------------------------------------------------------------------------
// Get the spherical representation of a vector
//---------------------------------------------------------------------------

void Vector::get_spherical( double &theta, double &phi, double &rlen ) const
{  
  rlen = len();
  theta = acos(c/rlen);    
  if (a>0)
    phi = atan(b/a);
  else 
    if (a<0)
      phi = atan(b/a) + M_PI;
    else 
      phi = (b>0) ? M_PI_2 : -1 * M_PI_2;
}




//---------------------------------------------------------------------------
// Assign to the vector using spherical coordinates
//---------------------------------------------------------------------------

int Vector::set_spherical( const double &theta, const double &phi, 
			   const double &rlen )
{
  if (theta > M_PI || theta <0)
    return 0;
  a = rlen * sin(theta) * cos(phi);
  b = rlen * sin(theta) * sin(phi);
  c = rlen * cos(theta);
  d = 1;
  return 1;
}


//---------------------------------------------------------------------------
// Get an orthogonal vector.
//---------------------------------------------------------------------------

void Vector::get_ortogonal( Vector &x ) const 
{
  if ( fabs(a) > TINY ) 
    {
      if ( fabs( b ) > TINY ) 
	{
	  x.a = b; x.b = -a; x.c = 0.0;
	}
      else {
	x.a = 0.0; x.b = -1.0; x.c = 0.0;
      }
    }
  else {
    x.a = 1.0; x.b = 0.0; x.c = 0.0;
  }
}


//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------

class ostream& operator<<( class ostream& os, const Vector& x )
{
  // os << "[" << x[0] << ", " << x[1] <<  ", " << x[2] << "]";
  os << x[0] << " " << x[1] <<  " " << x[2];
    
  return os;
}
